<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_201) on Tue Jun 11 21:47:06 AEST 2019 -->
<title>BlockOptimizedHistory (worldedit-core 7.0.0 API)</title>
<meta name="date" content="2019-06-11">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="BlockOptimizedHistory (worldedit-core 7.0.0 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html" title="class in com.sk89q.worldedit.history.changeset"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html" title="interface in com.sk89q.worldedit.history.changeset"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/sk89q/worldedit/history/changeset/BlockOptimizedHistory.html" target="_top">Frames</a></li>
<li><a href="BlockOptimizedHistory.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">com.sk89q.worldedit.history.changeset</div>
<h2 title="Class BlockOptimizedHistory" class="title">Class BlockOptimizedHistory</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li><a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html" title="class in com.sk89q.worldedit.history.changeset">com.sk89q.worldedit.history.changeset.ArrayListHistory</a></li>
<li>
<ul class="inheritance">
<li>com.sk89q.worldedit.history.changeset.BlockOptimizedHistory</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html" title="interface in com.sk89q.worldedit.history.changeset">ChangeSet</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">BlockOptimizedHistory</span>
extends <a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html" title="class in com.sk89q.worldedit.history.changeset">ArrayListHistory</a></pre>
<div class="block">An extension of <a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html" title="class in com.sk89q.worldedit.history.changeset"><code>ArrayListHistory</code></a> that stores <a href="../../../../../com/sk89q/worldedit/history/change/BlockChange.html" title="class in com.sk89q.worldedit.history.change"><code>BlockChange</code></a>s
 separately in two <code>ArrayList</code>s.

 <p>Whether this is a good idea or not is highly questionable, but this class
 exists because this is how history was implemented in WorldEdit for
 many years.</p></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/history/changeset/BlockOptimizedHistory.html#BlockOptimizedHistory--">BlockOptimizedHistory</a></span>()</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/history/changeset/BlockOptimizedHistory.html#add-com.sk89q.worldedit.history.change.Change-">add</a></span>(<a href="../../../../../com/sk89q/worldedit/history/change/Change.html" title="interface in com.sk89q.worldedit.history.change">Change</a>&nbsp;change)</code>
<div class="block">Add the given change to the history.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>java.util.Iterator&lt;<a href="../../../../../com/sk89q/worldedit/history/change/Change.html" title="interface in com.sk89q.worldedit.history.change">Change</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/history/changeset/BlockOptimizedHistory.html#backwardIterator--">backwardIterator</a></span>()</code>
<div class="block">Get a backward directed iterator that can be used for undo.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>java.util.Iterator&lt;<a href="../../../../../com/sk89q/worldedit/history/change/Change.html" title="interface in com.sk89q.worldedit.history.change">Change</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/history/changeset/BlockOptimizedHistory.html#forwardIterator--">forwardIterator</a></span>()</code>
<div class="block">Get a forward directed iterator that can be used for redo.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/history/changeset/BlockOptimizedHistory.html#size--">size</a></span>()</code>
<div class="block">Get the number of stored changes.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.com.sk89q.worldedit.history.changeset.ArrayListHistory">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;com.sk89q.worldedit.history.changeset.<a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html" title="class in com.sk89q.worldedit.history.changeset">ArrayListHistory</a></h3>
<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html#isRecordingChanges--">isRecordingChanges</a>, <a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html#setRecordChanges-boolean-">setRecordChanges</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="BlockOptimizedHistory--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>BlockOptimizedHistory</h4>
<pre>public&nbsp;BlockOptimizedHistory()</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="add-com.sk89q.worldedit.history.change.Change-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>add</h4>
<pre>public&nbsp;void&nbsp;add(<a href="../../../../../com/sk89q/worldedit/history/change/Change.html" title="interface in com.sk89q.worldedit.history.change">Change</a>&nbsp;change)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html#add-com.sk89q.worldedit.history.change.Change-">ChangeSet</a></code></span></div>
<div class="block">Add the given change to the history.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html#add-com.sk89q.worldedit.history.change.Change-">add</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html" title="interface in com.sk89q.worldedit.history.changeset">ChangeSet</a></code></dd>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html#add-com.sk89q.worldedit.history.change.Change-">add</a></code>&nbsp;in class&nbsp;<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html" title="class in com.sk89q.worldedit.history.changeset">ArrayListHistory</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>change</code> - the change</dd>
</dl>
</li>
</ul>
<a name="forwardIterator--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>forwardIterator</h4>
<pre>public&nbsp;java.util.Iterator&lt;<a href="../../../../../com/sk89q/worldedit/history/change/Change.html" title="interface in com.sk89q.worldedit.history.change">Change</a>&gt;&nbsp;forwardIterator()</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html#forwardIterator--">ChangeSet</a></code></span></div>
<div class="block">Get a forward directed iterator that can be used for redo.

 <p>The iterator may return the changes out of order, as long as the final
 result after all changes have been applied is correct.</p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html#forwardIterator--">forwardIterator</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html" title="interface in com.sk89q.worldedit.history.changeset">ChangeSet</a></code></dd>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html#forwardIterator--">forwardIterator</a></code>&nbsp;in class&nbsp;<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html" title="class in com.sk89q.worldedit.history.changeset">ArrayListHistory</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a forward directed iterator</dd>
</dl>
</li>
</ul>
<a name="backwardIterator--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>backwardIterator</h4>
<pre>public&nbsp;java.util.Iterator&lt;<a href="../../../../../com/sk89q/worldedit/history/change/Change.html" title="interface in com.sk89q.worldedit.history.change">Change</a>&gt;&nbsp;backwardIterator()</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html#backwardIterator--">ChangeSet</a></code></span></div>
<div class="block">Get a backward directed iterator that can be used for undo.

 <p>The iterator may return the changes out of order, as long as the final
 result after all changes have been applied is correct.</p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html#backwardIterator--">backwardIterator</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html" title="interface in com.sk89q.worldedit.history.changeset">ChangeSet</a></code></dd>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html#backwardIterator--">backwardIterator</a></code>&nbsp;in class&nbsp;<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html" title="class in com.sk89q.worldedit.history.changeset">ArrayListHistory</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a undo directed iterator</dd>
</dl>
</li>
</ul>
<a name="size--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>size</h4>
<pre>public&nbsp;int&nbsp;size()</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html#size--">ChangeSet</a></code></span></div>
<div class="block">Get the number of stored changes.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html#size--">size</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html" title="interface in com.sk89q.worldedit.history.changeset">ChangeSet</a></code></dd>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html#size--">size</a></code>&nbsp;in class&nbsp;<code><a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html" title="class in com.sk89q.worldedit.history.changeset">ArrayListHistory</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the change count</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../com/sk89q/worldedit/history/changeset/ArrayListHistory.html" title="class in com.sk89q.worldedit.history.changeset"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../com/sk89q/worldedit/history/changeset/ChangeSet.html" title="interface in com.sk89q.worldedit.history.changeset"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/sk89q/worldedit/history/changeset/BlockOptimizedHistory.html" target="_top">Frames</a></li>
<li><a href="BlockOptimizedHistory.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
